# 개선된 예약어.py에서 중복 검사
한국어_파이썬_예약어 = {
    # ----- 파이썬 예약어 (keywords) -----
    # 논리값 / None
    "거짓": "False",
    "참": "True",
    "없음": "None",

    # 논리 연산
    "그리고": "and",
    "또는": "or",
    "아니다": "not",

    # 조건/반복
    "만약": "if",
    "아니고만약": "elif",
    "아니면": "else",
    "동안": "while",
    "각각": "for",
    "안에": "in",
    "중단": "break",
    "계속": "continue",

    # 예외 처리
    "시도": "try",
    "예외": "except",
    "결국": "finally",
    "발생": "raise",

    # 함수/클래스/람다
    "정의": "def",
    "클래스": "class",
    "람다": "lambda",
    "반환": "return",
    "넘어가기": "pass",

    # 비동기 처리
    "비동기": "async",
    "기다림": "await",

    # 패턴 매칭 
    "매칭": "match",
    "경우": "case",

    # 기타 키워드
    "삭제": "del",
    "전역": "global",
    "비전역": "nonlocal",
    "로서": "as",
    "은": "is",
    "에서": "from",
    "불러오기": "import",
    "단언": "assert",
    "함께": "with",
    "생성": "yield",

    # ----- 파이썬 내장 함수 (built-in functions) -----
    "절댓값": "abs",
    "모두참": "all",
    "하나참": "any",
    "아스키": "ascii",
    "이진수": "bin",
    "불리언": "bool",
    "중단점": "breakpoint",
    "바이트배열": "bytearray",
    "바이트": "bytes",
    "호출가능": "callable",
    "문자": "chr",
    "클래스메서드": "classmethod",
    "컴파일": "compile",
    "복소수": "complex",
    "삭제속성": "delattr",
    "사전": "dict",
    "디렉터리": "dir",
    "몫나머지": "divmod",
    "열거": "enumerate",
    "평가": "eval",
    "실행": "exec",
    "필터": "filter",
    "실수": "float",
    "형식": "format",
    "고정집합": "frozenset",
    "속성얻기": "getattr",
    "전역변수": "globals",
    "존재여부": "hasattr",
    "해시": "hash",
    "도움말": "help",
    "16진수": "hex",
    "객체ID": "id",
    "입력": "input",
    "정수": "int",
    "인스턴스여부": "isinstance",
    "서브클래스여부": "issubclass",
    "반복자": "iter",
    "길이": "len",
    "리스트": "list",
    "지역변수": "locals",
    "맵": "map",
    "최대값": "max",
    "메모리뷰": "memoryview",
    "최소값": "min",
    "다음값": "next",
    "객체": "object",
    "8진수": "oct",
    "열기": "open",
    "유니코드값": "ord",
    "거듭제곱": "pow",
    "출력": "print",
    "속성": "property",
    "범위": "range",
    "표현식": "repr",
    "역순": "reversed",
    "반올림": "round",
    "집합": "set",
    "설정속성": "setattr",
    "슬라이스": "slice",
    "정렬": "sorted",
    "정적메서드": "staticmethod",
    "문자열": "str",
    "합계": "sum",
    "슈퍼클래스": "super",
    "튜플": "tuple",
    "타입": "type",
    "변수들": "vars",
    "압축": "zip",
    "모듈가져오기": "__import__",

    # ----- 추가 내장 함수들 -----
    "적용": "apply",
    "버퍼": "buffer",
    "바이트순서": "byteorder",
    "코드": "code",
    "공변": "coerce",
    "내부함수": "intern",
    "긴정수": "long",
    "원시입력": "raw_input",
    "문자열감소": "reduce",
    "다시로드": "reload",
    "유니코드": "unicode",
    "실행파일": "execfile",
    "파일": "file",

    # ----- 연산자 키워드 -----
    "이고": "and",
    "이거나": "or", 
    "가아니다": "not",
    "같다": "==",
    "다르다": "!=",
    "크다": ">",
    "작다": "<",
    "크거나같다": ">=",
    "작거나같다": "<=",

    # ----- 타입 관련 -----
    "정수타입": "int",
    "실수타입": "float",
    "문자열타입": "str",
    "불타입": "bool",
    "리스트타입": "list",
    "튜플타입": "tuple",
    "사전타입": "dict",
    "집합타입": "set",
    "바이트타입": "bytes",
    "없음타입": "type(None)",

    # ----- 특수 메서드 확장 -----
    "초기화": "__init__",
    "문자열화": "__str__",
    "표현": "__repr__",
    "길이": "__len__",
    "호출": "__call__",
    "반복자": "__iter__",
    "다음": "__next__",
    "포함": "__contains__",
    "덧셈": "__add__",
    "뺄셈": "__sub__",
    "곱셈": "__mul__",
    "나눗셈": "__truediv__",
    "정수나눗셈": "__floordiv__",
    "나머지": "__mod__",
    "거듭제곱": "__pow__",
    "같음": "__eq__",
    "다름": "__ne__",
    "작음": "__lt__",
    "작거나같음": "__le__",
    "큼": "__gt__",
    "크거나같음": "__ge__",
    "인덱싱": "__getitem__",
    "인덱스설정": "__setitem__",
    "인덱스삭제": "__delitem__",
    "속성접근": "__getattr__",
    "속성설정": "__setattr__",
    "속성삭제": "__delattr__",
    "진입": "__enter__",
    "종료": "__exit__",
    "해시": "__hash__",
    "불리언화": "__bool__",
    "바이트화": "__bytes__",
    "형식화": "__format__",
    "크기힌트": "__sizeof__",
    "복사": "__copy__",
    "깊은복사": "__deepcopy__",
    "상태얻기": "__getstate__",
    "상태설정": "__setstate__",
    "감소": "__reduce__",
    "감소확장": "__reduce_ex__",

    # ----- 새로운 문법 요소들 -----
    "모두생성": "yield from",  # yield from 구문
    "왈러스": ":=",            # 왈러스 연산자
    "타입힌트": ":",           # 타입 힌트
    "반환타입": "->",          # 반환 타입 힌트
    "포맷문자열": "f",         # f-string
    "원시문자열": "r",         # raw string
    "바이트문자열": "b",       # byte string
    "유니코드문자열": "u",     # unicode string (Python 2 호환)

    # ----- 패턴 매칭 확장 -----
    "와일드카드": "_",         # 와일드카드 패턴
    "또는패턴": "|",          # OR 패턴
    "가드조건": "if",         # 가드 조건

    # ----- 컨텍스트 매니저 -----
    "문맥관리자": "contextlib",
    "임시억제": "suppress",
    "리다이렉트출력": "redirect_stdout",
    "리다이렉트오류": "redirect_stderr",

    # ----- 데코레이터 관련 -----
    "데코레이터": "@",
    "속성장식": "property",
    "정적장식": "staticmethod", 
    "클래스장식": "classmethod",
    "캐시장식": "cache",
    "LRU캐시": "lru_cache",

    # ----- 타입 힌트 모듈 (typing) -----
    "타입힌트모듈": "typing",
    "리스트형": "List",
    "튜플형": "Tuple", 
    "사전형": "Dict",
    "집합형": "Set",
    "고정집합형": "FrozenSet",
    "옵션형": "Optional",
    "유니온형": "Union",
    "콜러블형": "Callable",
    "모든형": "Any",
    "타입변수": "TypeVar",
    "제네릭": "Generic",
    "리터럴": "Literal",
    "파이널": "Final",
    "노반환": "NoReturn",
    "클래스변수": "ClassVar",
    "자기참조": "Self",

    # ----- 파이썬 내장 예외 (수정된 버전) -----
    "예외": "Exception",
    "기본예외": "BaseException",
    "시스템종료": "SystemExit",
    "키보드인터럽트": "KeyboardInterrupt",
    "제너레이터종료": "GeneratorExit",
    "중단예외": "StopIteration",
    "비동기중단예외": "StopAsyncIteration",
    "산술오류": "ArithmeticError",
    "오버플로우오류": "OverflowError",
    "영으로나눔오류": "ZeroDivisionError",
    "부동소수점오류": "FloatingPointError",
    "속성오류": "AttributeError",
    "버퍼오류": "BufferError",
    "EOF오류": "EOFError",
    "입출력오류": "IOError",
    "OS오류": "OSError",
    "파일존재오류": "FileExistsError",
    "파일없음오류": "FileNotFoundError",
    "디렉터리없음오류": "NotADirectoryError",
    "디렉터리아님오류": "IsADirectoryError",
    "권한오류": "PermissionError",
    "프로세스찾을수없음오류": "ProcessLookupError",
    "시간초과오류": "TimeoutError",
    "참조오류": "ReferenceError",
    "메모리오류": "MemoryError",
    "인덱스오류": "IndexError",
    "키오류": "KeyError",
    "값오류": "ValueError",
    "타입오류": "TypeError",
    "이름오류": "NameError",
    "언바운드로컬오류": "UnboundLocalError",
    "모듈없음오류": "ModuleNotFoundError",
    "임포트오류": "ImportError",
    "중단오류": "InterruptedError",
    "런타임오류": "RuntimeError",
    "재귀오류": "RecursionError",
    "구현안됨오류": "NotImplementedError",
    "문법오류": "SyntaxError",
    "들여쓰기오류": "IndentationError",
    "탭오류": "TabError",
    "유니코드오류": "UnicodeError",
    "유니코드인코딩오류": "UnicodeEncodeError",
    "유니코드디코딩오류": "UnicodeDecodeError",
    "유니코드번역오류": "UnicodeTranslateError",
    "경고": "Warning",
    "사용자경고": "UserWarning",
    "폐기경고": "DeprecationWarning",
    "대기중경고": "PendingDeprecationWarning",
    "문법경고": "SyntaxWarning",
    "런타임경고": "RuntimeWarning",
    "미래기능경고": "FutureWarning",
    "임포트경고": "ImportWarning",
    "유니코드경고": "UnicodeWarning",
    "바이트경고": "BytesWarning",
    "자원경고": "ResourceWarning",

    # ----- 유용한 모듈들 -----
    "운영체제": "os",
    "시스템": "sys", 
    "시간": "time",
    "날짜시간": "datetime",
    "수학": "math",
    "랜덤": "random",
    "정규식": "re",
    "JSON": "json",
    "경로": "pathlib",
    "콜렉션": "collections",
    "반복도구": "itertools",
    "함수도구": "functools",
    "스레딩": "threading",
    "멀티프로세싱": "multiprocessing",
    "비동기IO": "asyncio",
    "HTTP요청": "requests",
    "URL해석": "urllib",
    "CSV": "csv",
    "피클": "pickle",
    "복사": "copy",
    "약한참조": "weakref",
    "가비지수집": "gc",
    "디스": "dis",
    "추적": "traceback",
    "로깅": "logging",
    "압축": "zipfile",
    "타르": "tarfile",
    "임시파일": "tempfile",
    "셸명령": "subprocess",
    "플랫폼": "platform",
}
